import QtQuick 2.6
import Sailfish.Silica 1.0
import Simple.Hybrid 1.0

Page {
    Calc {
        id: calc
        leftArg: parseFloat(leftArgField.text)
        rightArg: parseFloat(rightArgField.text)
        operation: operationSelector.operation
    }
    SilicaFlickable {
        anchors.fill: parent
        contentHeight: contentColumn.height

        Column {
            id: contentColumn
            width: parent.width
            spacing: Theme.paddingLarge

            PageHeader { title: qsTr("Calc") }
            TextField {
                id: leftArgField
                width: parent.width
                placeholderText: qsTr("Input left arg")
                validator: DoubleValidator { }
                inputMethodHints: Qt.ImhFormattedNumbersOnly
            }
            ComboBox {
                id: operationSelector

                readonly property int operation: [
                    Calc.Addition,
                    Calc.Subtraction,
                    Calc.Multiplication,
                    Calc.Division
                ][currentIndex]

                valueColor: Theme.primaryColor
                labelMargin: Theme.horizontalPageMargin / 2
                menu: ContextMenu {
                    MenuItem { text: "+" }
                    MenuItem { text: "-" }
                    MenuItem { text: "*" }
                    MenuItem { text: "/" }
                }
            }
            TextField {
                id: rightArgField
                width: parent.width
                placeholderText: qsTr("Input right arg")
                validator: DoubleValidator { }
                inputMethodHints: Qt.ImhFormattedNumbersOnly
            }
            Label {
                text: "="
                color: Theme.highlightColor
                anchors { left: parent.left; margins: Theme.horizontalPageMargin }
            }
            TextField {
                text: calc.result
                readOnly: true
                color: Theme.highlightColor
                width: parent.width
            }
        }
    }
}
