#include "Calc.h"

Calc::Calc(QObject *parent) : QObject(parent),
    _leftArg(0), _rightArg(0), _operation(Addition)
{
    QObject::connect(this, &Calc::leftArgChanged,
                     this, &Calc::resultChanged);
    QObject::connect(this, &Calc::rightArgChanged,
                     this, &Calc::resultChanged);
    QObject::connect(this, &Calc::operationChanged,
                     this, &Calc::resultChanged);
}

qreal Calc::leftArg() const
{
    return this->_leftArg;
}

qreal Calc::rightArg() const
{
    return this->_rightArg;
}

Calc::Operation Calc::operation() const
{
    return this->_operation;
}


qreal Calc::result() const
{
    switch (this->_operation) {
    case Addition:
        return this->_leftArg + this->_rightArg;
    case Subtraction:
        return this->_leftArg - this->_rightArg;
    case Multiplication:
        return this->_leftArg * this->_rightArg;
    case Division:
        return this->_leftArg / this->_rightArg;
    }
    return 0;
}

void Calc::setLeftArg(qreal leftArg)
{
    this->_leftArg = leftArg;
    emit leftArgChanged();
}

void Calc::setRightArg(qreal rightArg)
{
    this->_rightArg = rightArg;
    emit rightArgChanged();
}

void Calc::setOperation(Operation operation)
{
    this->_operation = operation;
    emit operationChanged();
}
