#ifndef CALC_H
#define CALC_H

#include <QObject>

class Calc : public QObject
{
    Q_OBJECT
    Q_PROPERTY(qreal leftArg READ leftArg WRITE setLeftArg NOTIFY leftArgChanged)
    Q_PROPERTY(qreal rightArg READ rightArg WRITE setRightArg NOTIFY rightArgChanged)
    Q_PROPERTY(Operation operation READ operation WRITE setOperation NOTIFY operationChanged)
    Q_PROPERTY(qreal result READ result NOTIFY resultChanged)

public:
    enum Operation { Addition, Subtraction, Multiplication, Division };
    Q_ENUM(Operation)

    explicit Calc(QObject *parent = nullptr);

    qreal leftArg() const;
    qreal rightArg() const;
    Operation operation() const;
    qreal result() const;

signals:
    void leftArgChanged();
    void rightArgChanged();
    void operationChanged();
    void resultChanged();

public slots:
    void setLeftArg(qreal leftArg);
    void setRightArg(qreal rightArg);
    void setOperation(Operation operation);

private:
    qreal _leftArg;
    qreal _rightArg;
    Operation _operation;
};

#endif // CALC_H
